!23456789a123456789b123456789c123456789d123456789e123456789f123456789g12
!
! Copyright D.J. Jeffery, 2006jan01.
!
!  aaread.f is for creating synow dossier. 
!
!   References:
!
!     \bibitem[Metcalf et al.(2004)]{metcalf} Metcalf, M., Reid, J., \&~Cohen, M. 2004,
!          Fortran 95/2003 Explained
!          (Oxford:  Oxford University Press) (MRC)
!          % Pretty good reference book.
!
!     \bibitem[Press et al.(1992)]{press1992} Press, W. H., Teukolsky, S. A.,
!          Vetterling, W. T., \& Flannery, B. P. 1992,
!            Numerical Recipes in Fortran
!            (Cambridge:  Cambridge University Press)
!            % Bill should have given me a complimentary copy when
!            % I co-taught with him in 1993!
!
!----------------------------------------------------------------------
!
      program aaread
      implicit none
!
      integer, parameter :: nfile=17
      integer, parameter :: nheader=6
!
      character :: afile(nfile)*80=(/
     &                            'MANIFEST.BIN                   ',                    &   ! Short list of synow files.
     &                            'MANIFEST.SRC                   ',                    &   ! Longer list of synow files.
     &                            'README.SRC                     ',                    &   ! Nonsense file?
     &                            'README.BIN                     ',                    &   ! The real readme file.
!
     &                            'makefile                       ',                    &   ! The makefile.
     &                            'in.dat                         ',                    &   ! Example input file. 
     &                            'ref.dat                        ',                    &   ! The reference lines.
!     &                            'linelist.info                   ',                    &   ! Not clear what this is.  It's long.
!     &                            'synow                          ',                    &   ! Something in bad code.
!
     &                            'aaread.f                       ',                    &   ! This code itself. 
     &                            'alt.f                          ',                    &   ! Code
     &                            'getbin.f                       ',                    &   ! Code
     &                            'locnorm.f                      ',                    &   ! Code
     &                            'locnormt.dat                   ',                    &   ! Data file for locnormt.dat. 
     &                            'locnormt.f                     ',                    &   ! An example driver code for locormt.f.
     &                            'initial.f                      ',                    &   ! Code
     &                            'source.f                       ',                    &   ! Code
     &                            'spectrum.f                     ',                    &   ! Code
!
     &                            'synnew.f                       '/)                   &   ! Main program of synow.
      character :: header(nheader)*72
      integer :: i,j,k,l,m,n
      character :: record*180
!
      call date_and_time(record)
      record=record(1:4)//'_'//record(5:6)//'_'//record(7:8)
!
      header(1)='!' 
      header(2)='!23456789a123456789b123456789c123456789d123456789e'//                  &
     &          '123456789f123456789g12'
      header(3)='!' 
      header(4)='!'//' Date ccyymmdd '//trim(record) 
      header(5)='!' 
      header(6)='!-------------------------------------------------'//                  &
     &          '----------------------'
!
      open(unit=1,file='tmp',status='unknown',action='write')
!
       write(1,'(a)') (trim(header(j)),j=1,nheader-1)
       write(1,'(2a)') '! files '
       write(1,'(a)') '!'
       write(1,'(a)') header(6) 
       write(1,'(a)') '!'
       do402 : do i=1,nfile
        write(1,'(2a)') '! ',trim(afile(i)) 
       end do do402
!
       do410 : do i=1,nfile
        write(*,*) i,trim(afile(i))
        open(unit=2,file=trim(afile(i)),status='old',action='read')
        write(1,'(a)') (trim(header(j)),j=1,nheader-1)
        write(1,'(2a)') '! file ',trim(afile(i)) 
        write(1,'(a)') '!'
        write(1,'(a)') header(6) 
        write(1,'(a)') '!'
         do430 : do 
          read(2,'(a)',end=110) record
          write(1,'(a)') trim(record)
         end do do430
  110    continue
        close(unit=2)
       end do do410
!
      close(unit=1)
!
      end program aaread
